Feature: Detect bad arguments and flags
  Background: 
    Given A configuration exists
  #################################################
  # Missing data from arguments
  ################################################
  Scenario: User specifies '--config-dir' without the directory during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "--config-dir"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Configuration directory"
  Scenario: User specifies '-c' without the directory during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "-c"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Configuration directory"
  Scenario: User specifies '--cge-id' without the id during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "--cge-id"
    When I run the application
    Then The application should fail
    And I should see an error message containing "CGE Backup ID"
  Scenario: User specifies '-i' without the id during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "-i"
    When I run the application
    Then The application should fail
    And I should see an error message containing "CGE Backup ID"
  Scenario: User specifies '--date-id' without the id during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "--date-id"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Date ID"
  Scenario: User specifies '-d' without the id during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "-d"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Date ID"
  Scenario: User specifies '--sync-dir' without the directory during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "--sync-dir"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Configuration directory"
  Scenario: User specifies '-s' without the directory during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "-s"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Configuration directory"
  Scenario: User specifies '--host' without the host during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "--host"
    When I run the application
    Then The application should fail
    And I should see an error message containing "MySQL host"
  Scenario: User specifies '-h' without the host during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "-h"
    When I run the application
    Then The application should fail
    And I should see an error message containing "MySQL host"
  Scenario: User specifies '--port' without the port during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "--port"
    When I run the application
    Then The application should fail
    And I should see an error message containing "MySQL port"
  Scenario: User specifies '-P' without the port during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "-P"
    When I run the application
    Then The application should fail
    And I should see an error message containing "MySQL port"
  Scenario: User specifies '--user' without the user during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "--user"
    When I run the application
    Then The application should fail
    And I should see an error message containing "MySQL username"
  Scenario: User specifies '-u' without the user during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "-u"
    When I run the application
    Then The application should fail
    And I should see an error message containing "MySQL username"

  #################################################
  # Sync commands specified during export
  #################################################
  Scenario: User specifies '-d 1' during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "-d 1"
    When I run the application
    Then The application should fail
    And I should see an error message containing "sync option"
  Scenario: User specifies '--date-id 1' during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "--date-id 1"
    When I run the application
    Then The application should fail
    And I should see an error message containing "sync option"
  Scenario: User specifies '--no-sync-configs' during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "--no-sync-configs"
    When I run the application
    Then The application should fail
    And I should see an error message containing "sync option"
  Scenario: User specifies '--sync-dir' during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "--sync-dir /tmp/insxsync"
    When I run the application
    Then The application should fail
    And I should see an error message containing "sync option"
  Scenario: User specifies '-s' during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "-s /tmp/insxsync"
    When I run the application
    Then The application should fail
    And I should see an error message containing "sync option"
  Scenario: User specifies '--sync-data' during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "--sync-data"
    When I run the application
    Then The application should fail
    And I should see an error message containing "sync option"
  Scenario: User specifies '--host 127.0.0.1' during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "--host 127.0.0.1"
    When I run the application
    Then The application should fail
    And I should see an error message containing "sync option"
  Scenario: User specifies '-h 127.0.0.1' during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "-h 127.0.0.1"
    When I run the application
    Then The application should fail
    And I should see an error message containing "sync option"
  Scenario: User specifies '--port 3306' during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "--port 3306"
    When I run the application
    Then The application should fail
    And I should see an error message containing "sync option"
  Scenario: User specifies '-P 3306' during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "-P 3306"
    When I run the application
    Then The application should fail
    And I should see an error message containing "sync option"
  Scenario: User specifies '--user' during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "--user root"
    When I run the application
    Then The application should fail
    And I should see an error message containing "sync option"
  Scenario: User specifies '-u' during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "-u root"
    When I run the application
    Then The application should fail
    And I should see an error message containing "sync option"
  Scenario: User specifies '--password' during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "--password Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "sync option"
  Scenario: User specifies '-p' during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "-p Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "sync option"
  #################################################
  # Export commands specified during sync
  #################################################
  Scenario: User specifies '--no-export-configs' during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "--no-export-configs"
    When I run the application
    Then The application should fail
    And I should see an error message containing "export option"
  Scenario: User specifies '--config-dir' during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "--config-dir /tmp/insxsync"
    When I run the application
    Then The application should fail
    And I should see an error message containing "export option"
  Scenario: User specifies '-c' during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "-c /tmp/insxsync"
    When I run the application
    Then The application should fail
    And I should see an error message containing "export option"
  Scenario: User specifies '--no-export-data' during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "--no-export-data"
    When I run the application
    Then The application should fail
    And I should see an error message containing "export option"
  Scenario: User specifies '--cge-id 1' during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "--cge-id 1"
    When I run the application
    Then The application should fail
    And I should see an error message containing "export option"
  Scenario: User specifies '-i 1' during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "-i 1"
    When I run the application
    Then The application should fail
    And I should see an error message containing "export option"
  #################################################
  # Argument validation
  #################################################
  Scenario: User specifies '--date-id' with bad id during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "--date-id BADDATA"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error: Date ID must be an integer."
  Scenario: User specifies '-d' with bad id during sync
    Given I am going to run the program
    And I specify the command "sync"
    And I specify "-d BADDATA"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error: Date ID must be an integer."
  Scenario: User specifies '--cge-id' with bad id during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "--cge-id BADDATA"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error: CGE Backup ID must be an integer."
  Scenario: User specifies '-i' with bad id during export
    Given I am going to run the program
    And I specify the command "export"
    And I specify "-i BADDATA"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error: CGE Backup ID must be an integer."