Feature: Listing Available Synchronization Points
  Background:
    Given A configuration exists
#################################################
#  Synchronization Points Irrelevant
#################################################
  Scenario: User wants to list all synchronization points (export flags)
    Given I am going to run the program
    And I specify the command "list"
    And I specify flags for export
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error:"
    And I should see an error message containing "export option"
  Scenario: User wants to list all synchronization points (import flags)
    Given I am going to run the program
    And I specify the command "list"
    And I specify flags for sync
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error:"
    And I should see an error message containing "sync option"
  Scenario: User wants to list database synchronization points (export flags)
    Given I am going to run the program
    And I specify the command "list-db"
    And I specify flags for export
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error:"
    And I should see an error message containing "export option"
  Scenario: User wants to list database synchronization points (import flags)
    Given I am going to run the program
    And I specify the command "list-db"
    And I specify flags for sync
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error:"
    And I should see an error message containing "sync option"
  Scenario: User wants to list configuration synchronization points (export flags)
    Given I am going to run the program
    And I specify the command "list-conf"
    And I specify flags for export
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error:"
    And I should see an error message containing "export option"
  Scenario: User wants to list configuration synchronization points (import flags)
    Given I am going to run the program
    And I specify the command "list-conf"
    And I specify flags for sync
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error:"
    And I should see an error message containing "sync option"
  Scenario: User wants to list complete synchronization points (export flags)
    Given I am going to run the program
    And I specify the command "list-complete"
    And I specify flags for export
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error:"
    And I should see an error message containing "export option"
  Scenario: User wants to list complete synchronization points (import flags)
    Given I am going to run the program
    And I specify the command "list-complete"
    And I specify flags for sync
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error:"
    And I should see an error message containing "sync option"
#################################################
#  Synchronization Points Exist
#################################################
  Scenario: User wants to list all synchronization points
    Given I am going to run the program
    And I specify the command "list"
    And Synchronization points exist
    And I input the following "Password001"
    When I run the application
    Then I should see a list of synchronization points
  Scenario: User wants to list database synchronization points
    Given I am going to run the program
    And I specify the command "list-db"
    And Synchronization points exist
    And I input the following "Password001"
    When I run the application
    Then I should see a list of synchronization points
    And All the synchronization points should include database dumps
  Scenario: User wants to list configuration synchronization points
    Given I am going to run the program
    And I specify the command "list-conf"
    And Synchronization points exist
    And I input the following "Password001"
    When I run the application
    Then I should see a list of synchronization points
    And All the synchronization points should include configurations
  Scenario: User wants to list complete synchronization points
    Given I am going to run the program
    And I specify the command "list-complete"
    And Synchronization points exist
    And I input the following "Password001"
    When I run the application
    Then I should see a list of synchronization points
    And All the synchronization points should include database dumps
    And All the synchronization points should include configurations
#################################################
#  Synchronization Points Do Not Exist
#################################################
  Scenario: User wants to list all synchronization points (none exist)
    Given I am going to run the program
    And I specify the command "list"
    And Synchronization points do not exist
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points found"
  Scenario: User wants to list database synchronization points (none exist)
    Given I am going to run the program
    And I specify the command "list-db"
    And Synchronization points do not exist
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points found"
  Scenario: User wants to list configuration synchronization points (none exist)
    Given I am going to run the program
    And I specify the command "list-conf"
    And Synchronization points do not exist
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points found"
  Scenario: User wants to list complete synchronization points (none exist)
    Given I am going to run the program
    And I specify the command "list-complete"
    And Synchronization points do not exist
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points found"