#!/bin/bash
USER="root"
PASSWORD="Password001"
HOST="127.0.0.1"
PORT="3306"
DBS=( aetna23feb cchpsc23feb cvtyc23feb cvty23feb edifiles23feb emp23feb enroll23feb healthspan23feb hixenroll23feb  masterplans23feb starmount23feb summacare23feb tem23feb )

echo "********************************************************************************"
echo "Starting restore at:" `date`
START=`date +%s`

for DB in ${DBS[@]}; do
	echo "--------------------------------------------------------------------------------"
	echo "Starting to restore ${DB} at:" `date`
	DBSTART=`date +%s`
	
	mysql -u${USER} -p${PASSWORD} -h ${HOST} -P${PORT} < ${DB}.sql
	
	DBEND=`date +%s`
	echo "Finished restoring ${DB} at:" `date`
	DIFF=`expr $DBEND - $DBSTART`
	echo "Elapsed time:" ${DIFF}s
done

echo "--------------------------------------------------------------------------------"
END=`date +%s`
echo "Finished restore at:" `date`
DIFF=`expr $END - $START`
echo "Total time:" ${DIFF}s
echo "********************************************************************************"

