Feature: Synchronization
  Background:
    Given A configuration exists
  #################################################
  # Configuration Directory, Sync Point, and Database connection irrelevant
  #################################################
  Scenario: User wants to sync (No Configs) (No Database)
    Given I am going to run the program
    And The database is running
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--no-sync-configs"
    And I specify "--user root"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Configuration and database synchronizations both disabled. Nothing to do! Exiting..."
  Scenario: User wants to sync (No Configs) (Database and no credentials)
    Given I am going to run the program
    And The database is running
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--no-sync-configs"
    And I specify "--sync-data"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Database username not specified and is required for all synchronization operations"
  Scenario: User wants to sync    (Configs) (Database) (Doesn't Specify Username)
    Given I am going to run the program
    And The database is running
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Database username not specified and is required for all synchronization operations"
  Scenario: User wants to sync (No Configs) (Database) (Specifies Sync Dir)
    Given I am going to run the program
    And The database is running
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--no-sync-configs"
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify valid database credentials
    When I run the application
    Then The application should fail
    And I should see an error message containing "Synchronization directory specified but configuration sync disabled. Please check your command. Exiting..."
  Scenario: User wants to sync (No Configs) (Database) (Doesn't Specify Username)
    Given I am going to run the program
    And The database is running
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Database username not specified and is required for all synchronization operations"
  #################################################
  # Configuration Directory Exists
  # Sync Point Exists
  # Database connection works
  #################################################
  Scenario: User wants to sync (Configs)    (No Database) (Default Sync Dir)     (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be unchanged
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (No Database) (Default Sync Dir)     (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be unchanged
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (No Database) (Specifies Sync Dir)   (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-dir /tmp/insxsync"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be unchanged
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (No Database) (Specifies Sync Dir)   (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--date-id 1"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be unchanged
    And The config files should be updated

  Scenario: User wants to sync (No Configs) (Database)    (Default Parameters)   (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And I am going to run a sync
    And Configurations exist at the default location
    And I specify "--no-sync-configs"
    And I specify "--sync-data"
    And I specify valid database credentials
    And I input the following "Password001"
    And I select the option "n"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be unchanged
  Scenario: User wants to sync (No Configs) (Database)    (Default Parameters)   (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And I am going to run a sync
    And Configurations exist at the default location
    And I specify "--no-sync-configs"
    And I specify "--sync-data"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    And I select the option "n"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be unchanged
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Host only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And I am going to run a sync
    And Configurations exist at the default location
    And I specify "--no-sync-configs"
    And I specify "--sync-data"
    And I specify "--host 127.0.0.1"
    And I specify valid database credentials
    And I input the following "Password001"
    And I select the option "n"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be unchanged
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Host only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And I am going to run a sync
    And Configurations exist at the default location
    And I specify "--no-sync-configs"
    And I specify "--sync-data"
    And I specify "--host 127.0.0.1"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    And I select the option "n"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be unchanged
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Port only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And I am going to run a sync
    And Configurations exist at the default location
    And I specify "--no-sync-configs"
    And I specify "--sync-data"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    And I select the option "n"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be unchanged
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Port only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And I am going to run a sync
    And Configurations exist at the default location
    And I specify "--no-sync-configs"
    And I specify "--sync-data"
    And I specify "--port 3306"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    And I select the option "n"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be unchanged
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Parameters) (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And I am going to run a sync
    And Configurations exist at the default location
    And I specify "--no-sync-configs"
    And I specify "--sync-data"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    And I select the option "n"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be unchanged
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Parameters) (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And I am going to run a sync
    And Configurations exist at the default location
    And I specify "--no-sync-configs"
    And I specify "--sync-data"
    And I specify "--date-id 1"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    And I select the option "n"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be unchanged

  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Default Parameters)   (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Default Parameters)   (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Host only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--host 127.0.0.1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Host only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--host 127.0.0.1"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Port only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Port only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--port 3306"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Parameters) (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Parameters) (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--date-id 1"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated

  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Default Parameters)   (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Default Parameters)   (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Host only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--host 127.0.0.1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Host only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--host 127.0.0.1"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Port only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Port only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--port 3306"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Parameters) (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Parameters) (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--date-id 1"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The synchronization should be successful
    And The databases should be updated
    And The config files should be updated

  ################################################
  # Configuration Directory Does not Exist
  # Sync Point Exists
  # Database connection works
  ################################################
  Scenario: User wants to sync (Configs)    (No Database) (Default Sync Dir)     (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at the default location
    And I am going to run a sync
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Synchronization directory '/var/www/exchange_app/data/subdomain' does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (No Database) (Default Sync Dir)     (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at the default location
    And I am going to run a sync
    And I specify valid database credentials
    And I specify "--date-id 1"
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Synchronization directory '/var/www/exchange_app/data/subdomain' does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (No Database) (Specifies Sync Dir)   (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify valid database credentials
    And I specify "--sync-dir /tmp/insxsync"
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error: Synchronization directory does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (No Database) (Specifies Sync Dir)   (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify valid database credentials
    And I specify "--date-id 1"
    And I specify "--sync-dir /tmp/insxsync"
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error: Synchronization directory does not exist. Exiting..."

  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Default Parameters)   (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Synchronization directory '/var/www/exchange_app/data/subdomain' does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Default Parameters)   (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Synchronization directory '/var/www/exchange_app/data/subdomain' does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Host only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--host 127.0.0.1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Synchronization directory '/var/www/exchange_app/data/subdomain' does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Host only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--host 127.0.0.1"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Synchronization directory '/var/www/exchange_app/data/subdomain' does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Port only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Synchronization directory '/var/www/exchange_app/data/subdomain' does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Port only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--port 3306"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Synchronization directory '/var/www/exchange_app/data/subdomain' does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Parameters) (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Synchronization directory '/var/www/exchange_app/data/subdomain' does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Parameters) (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--date-id 1"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Synchronization directory '/var/www/exchange_app/data/subdomain' does not exist. Exiting..."

  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Default Parameters)   (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error: Synchronization directory does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Default Parameters)   (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error: Synchronization directory does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Host only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--host 127.0.0.1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error: Synchronization directory does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Host only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--host 127.0.0.1"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error: Synchronization directory does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Port only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error: Synchronization directory does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Port only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--port 3306"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error: Synchronization directory does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Parameters) (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error: Synchronization directory does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Parameters) (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And Configurations do not exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--date-id 1"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Argument Error: Synchronization directory does not exist. Exiting..."

  #################################################
  # Configuration Directory Exists
  # Sync Point Does not Exist
  # Database connection works
  #################################################
  Scenario: User wants to sync (Configs)    (No Database) (Default Sync Dir)     (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points exist. Exiting..."
  Scenario: User wants to sync (Configs)    (No Database) (Default Sync Dir)     (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify valid database credentials
    And I specify "--date-id 1"
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Specified synchronization point does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (No Database) (Specifies Sync Dir)   (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify valid database credentials
    And I specify "--sync-dir /tmp/insxsync"
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points exist. Exiting..."
  Scenario: User wants to sync (Configs)    (No Database) (Specifies Sync Dir)   (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify valid database credentials
    And I specify "--date-id 1"
    And I specify "--sync-dir /tmp/insxsync"
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Specified synchronization point does not exist. Exiting..."

  Scenario: User wants to sync (No Configs) (Database)    (Default Parameters)   (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points exist. Exiting..."
  Scenario: User wants to sync (No Configs) (Database)    (Default Parameters)   (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Specified synchronization point does not exist. Exiting..."
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Host only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify "--host 127.0.0.1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points exist. Exiting..."
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Host only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify "--host 127.0.0.1"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Specified synchronization point does not exist. Exiting..."
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Port only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points exist. Exiting..."
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Port only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify "--port 3306"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Specified synchronization point does not exist. Exiting..."
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Parameters) (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points exist. Exiting..."
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Parameters) (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify "--date-id 1"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Specified synchronization point does not exist. Exiting..."

  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Default Parameters)   (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Default Parameters)   (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Specified synchronization point does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Host only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--host 127.0.0.1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Host only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--host 127.0.0.1"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Specified synchronization point does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Port only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Port only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--port 3306"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Specified synchronization point does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Parameters) (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Default Sync Dir) (Specifies Parameters) (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at the default location
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--date-id 1"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Specified synchronization point does not exist. Exiting..."

  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Default Parameters)   (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Default Parameters)   (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Specified synchronization point does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Host only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--host 127.0.0.1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Host only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--host 127.0.0.1"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Specified synchronization point does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Port only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Port only)  (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--port 3306"
    And I specify "--date-id 1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Specified synchronization point does not exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Parameters) (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "No synchronization points exist. Exiting..."
  Scenario: User wants to sync (Configs)    (Database)    (Specifies Sync Dir) (Specifies Parameters) (Specifies Credentials) (Specifies Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points do not exist
    And Configurations exist at "/tmp/insxsync"
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--sync-dir /tmp/insxsync"
    And I specify "--date-id 1"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "Specified synchronization point does not exist. Exiting..."

  #################################################
  # Configuration Directory Exists
  # Sync Point Exists
  # Database host does not respond
  #################################################
  Scenario: User wants to sync (No Configs) (Database)    (Default Parameters)   (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is not running
    And Synchronization points exist
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "did not respond."
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Host only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is not running
    And Synchronization points exist
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify "--host 127.0.0.1"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "did not respond."
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Port only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is not running
    And Synchronization points exist
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "did not respond."
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Parameters) (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is not running
    And Synchronization points exist
    And I am going to run a sync
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify valid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "did not respond."

  #################################################
  # Configuration Directory Exists
  # Sync Point Exists
  # Database refuses credentials
  #################################################
  Scenario: User wants to sync (No Configs) (Database)    (Default Parameters)   (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And I am going to run a sync
    And I specify valid database credentials
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify invalid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "MySQL access denied for user"
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Host only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And I am going to run a sync
    And I specify valid database credentials
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify "--host 127.0.0.1"
    And I specify invalid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "MySQL access denied for user"
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Port only)  (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And I am going to run a sync
    And I specify valid database credentials
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify "--port 3306"
    And I specify invalid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "MySQL access denied for user"
  Scenario: User wants to sync (No Configs) (Database)    (Specifies Parameters) (Specifies Credentials) (Default Date ID)
    Given I am going to run the program
    And The database is running
    And Synchronization points exist
    And I am going to run a sync
    And I specify valid database credentials
    And I specify "--sync-data"
    And I specify "--no-sync-configs"
    And I specify "--host 127.0.0.1"
    And I specify "--port 3306"
    And I specify invalid database credentials
    And I input the following "Password001"
    When I run the application
    Then The application should fail
    And I should see an error message containing "MySQL access denied for user"